<template>
	<section class="wishlist-intake-type">
		<cdx-field
			:is-fieldset="true"
			:status="status"
			:messages="messages"
			:disabled="disabled"
		>
			<cdx-radio
				v-for="radio in radios"
				:key="'radio-' + radio.value"
				:model-value="type"
				name="radio-group-descriptions"
				:input-value="radio.value"
				@input="$emit( 'update:type', $event.target.value )"
			>
				{{ radio.label }}
				<template #description>
					{{ radio.description }}
				</template>
			</cdx-radio>
			<template #label>
				{{ $i18n( 'communitywishlist-wishtype-label' ).text() }}
			</template>
			<template #description>
				{{ $i18n( 'communitywishlist-wishtype-description' ).text() }}
			</template>
		</cdx-field>
	</section>
</template>

<script>
import { defineComponent } from 'vue';
import { CdxField, CdxRadio } from '@wikimedia/codex';
import Wish from '../common/Wish.js';

export default defineComponent( {
	name: 'TypeSection',
	components: {
		CdxField,
		CdxRadio
	},
	props: {
		type: { type: String, default: null },
		status: { type: String, default: 'default' },
		disabled: { type: Boolean, default: false }
	},
	emits: [
		'update:type'
	],
	setup() {
		const radios = [
			{
				label: mw.msg( 'communitywishlist-wishtype-feature-label' ),
				description: mw.msg( 'communitywishlist-wishtype-feature-description' ),
				value: Wish.TYPE_FEATURE
			},
			{
				label: mw.msg( 'communitywishlist-wishtype-bug-label' ),
				description: mw.msg( 'communitywishlist-wishtype-bug-description' ),
				value: Wish.TYPE_BUG
			},
			{
				label: mw.msg( 'communitywishlist-wishtype-change-label' ),
				description: mw.msg( 'communitywishlist-wishtype-change-description' ),
				value: Wish.TYPE_CHANGE
			},
			{
				label: mw.msg( 'communitywishlist-wishtype-unknown-label' ),
				description: mw.msg( 'communitywishlist-wishtype-unknown-description' ),
				value: Wish.TYPE_UNKNOWN
			}
		];

		return {
			radios
		};
	},
	data() {
		return {
			messages: {}
		};
	},
	watch: {
		status: {
			handler( newStatus ) {
				if ( newStatus === 'error' ) {
					this.messages = { error: mw.msg( 'communitywishlist-wishtype-error' ) };
				} else {
					this.messages = {};
				}
			}
		}
	}
} );
</script>
